<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (65)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="prototype-methods-objects-without-proto">
      Prototype methods, objects without <strong>proto</strong>
    </h1>
    <p>
      In the first chapter of this section, we mentioned that there are modern
      methods to setup a prototype.
    </p>
    <p>
      The <code>__proto__</code> is considered outdated and somewhat deprecated
      (in browser-only part of the JavaScript standard).
    </p>
    <p>The modern methods are:</p>
    <ul>
      <li>
        <a href="mdn:js/Object/create">Object.create(proto, [descriptors])</a> –
        creates an empty object with given <code>proto</code> as
        <code>[[Prototype]]</code> and optional property descriptors.
      </li>
      <li>
        <a href="mdn:js/Object/getPrototypeOf">Object.getPrototypeOf(obj)</a> –
        returns the <code>[[Prototype]]</code> of <code>obj</code>.
      </li>
      <li>
        <a href="mdn:js/Object/setPrototypeOf"
          >Object.setPrototypeOf(obj, proto)</a
        >
        – sets the <code>[[Prototype]]</code> of <code>obj</code> to
        <code>proto</code>.
      </li>
    </ul>
    <p>These should be used instead of <code>__proto__</code>.</p>
    <p>For instance:</p>
    <p>```js run let animal = { eats: true };</p>
    <p>
      // create a new object with animal as a prototype <em>!</em> let rabbit =
      Object.create(animal); <em>/!</em>
    </p>
    <p>alert(rabbit.eats); // true</p>
    <p>
      <em>!</em> alert(Object.getPrototypeOf(rabbit) === animal); // true
      <em>/!</em>
    </p>
    <p>
      <em>!</em> Object.setPrototypeOf(rabbit, {}); // change the prototype of
      rabbit to {} <em>/!</em> ```
    </p>
    <p>
      <code>Object.create</code> has an optional second argument: property
      descriptors. We can provide additional properties to the new object there,
      like this:
    </p>
    <p>```js run let animal = { eats: true, };</p>
    <p>let rabbit = Object.create(animal, { jumps: { value: true, }, });</p>
    <p>alert(rabbit.jumps); // true ```</p>
    <p>
      The descriptors are in the same format as described in the chapter
      <a href="info:property-descriptors" class="uri"
        >info:property-descriptors</a
      >.
    </p>
    <p>
      We can use <code>Object.create</code> to perform an object cloning more
      powerful than copying properties in <code>for..in</code>:
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> clone <span class="op">=</span> <span class="va">Object</span>.<span class="at">create</span>(</a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="va">Object</span>.<span class="at">getPrototypeOf</span>(obj)<span class="op">,</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="va">Object</span>.<span class="at">getOwnPropertyDescriptors</span>(obj)</a>
<a class="sourceLine" id="cb1-4" title="4">)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      This call makes a truly exact copy of <code>obj</code>, including all
      properties: enumerable and non-enumerable, data properties and
      setters/getters – everything, and with the right
      <code>[[Prototype]]</code>.
    </p>
    <h2 id="brief-history">Brief history</h2>
    <p>
      If we count all the ways to manage <code>[[Prototype]]</code>, there are a
      lot! Many ways to do the same thing!
    </p>
    <p>Why?</p>
    <p>That’s for historical reasons.</p>
    <ul>
      <li>
        The <code>"prototype"</code> property of a constructor function has
        worked since very ancient times.
      </li>
      <li>
        Later, in the year 2012, <code>Object.create</code> appeared in the
        standard. It gave the ability to create objects with a given prototype,
        but did not provide the ability to get/set it. So browsers implemented
        the non-standard <code>__proto__</code> accessor that allowed the user
        to get/set a prototype at any time.
      </li>
      <li>
        Later, in the year 2015, <code>Object.setPrototypeOf</code> and
        <code>Object.getPrototypeOf</code> were added to the standard, to
        perform the same functionality as <code>__proto__</code>. As
        <code>__proto__</code> was de-facto implemented everywhere, it was
        kind-of deprecated and made its way to the Annex B of the standard, that
        is: optional for non-browser environments.
      </li>
    </ul>
    <p>As of now we have all these ways at our disposal.</p>
    <p>
      Why was <code>__proto__</code> replaced by the functions
      <code>getPrototypeOf/setPrototypeOf</code>? That’s an interesting
      question, requiring us to understand why <code>__proto__</code> is bad.
      Read on to get the answer.
    </p>
    <p>
      ``<code>warn header="Don't change</code>[[Prototype]]<code
        >on existing objects if speed matters" Technically, we can get/set</code
      >[[Prototype]]<code
        >at any time. But usually we only set it once at the object creation
        time and don't modify it anymore:</code
      >rabbit<code>inherits from</code>animal`, and that is not going to change.
    </p>
    <p>
      And JavaScript engines are highly optimized for this. Changing a prototype
      “on-the-fly” with <code>Object.setPrototypeOf</code> or
      <code>obj.__proto__=</code> is a very slow operation as it breaks internal
      optimizations for object property access operations. So avoid it unless
      you know what you’re doing, or JavaScript speed totally doesn’t matter for
      you.
    </p>
    <pre><code>
## &quot;Very plain&quot; objects [#very-plain]

As we know, objects can be used as associative arrays to store key/value pairs.

...But if we try to store *user-provided* keys in it (for instance, a user-entered dictionary), we can see an interesting glitch: all keys work fine except `&quot;__proto__&quot;`.

Check out the example:

```js run
let obj = {};

let key = prompt(&quot;What&#39;s the key?&quot;, &quot;__proto__&quot;);
obj[key] = &quot;some value&quot;;

alert(obj[key]); // [object Object], not &quot;some value&quot;!</code></pre>
    <p>
      Here, if the user types in <code>__proto__</code>, the assignment is
      ignored!
    </p>
    <p>
      That shouldn’t surprise us. The <code>__proto__</code> property is
      special: it must be either an object or <code>null</code>. A string can
      not become a prototype.
    </p>
    <p>
      But we didn’t <em>intend</em> to implement such behavior, right? We want
      to store key/value pairs, and the key named <code>"__proto__"</code> was
      not properly saved. So that’s a bug!
    </p>
    <p>
      Here the consequences are not terrible. But in other cases we may be
      assigning object values, and then the prototype may indeed be changed. As
      a result, the execution will go wrong in totally unexpected ways.
    </p>
    <p>
      What’s worse – usually developers do not think about such possibility at
      all. That makes such bugs hard to notice and even turn them into
      vulnerabilities, especially when JavaScript is used on server-side.
    </p>
    <p>
      Unexpected things also may happen when assigning to <code>toString</code>,
      which is a function by default, and to other built-in methods.
    </p>
    <p>How can we avoid this problem?</p>
    <p>
      First, we can just switch to using <code>Map</code> for storage instead of
      plain objects, then everything’s fine.
    </p>
    <p>
      But <code>Object</code> can also serve us well here, because language
      creators gave thought to that problem long ago.
    </p>
    <p>
      <code>__proto__</code> is not a property of an object, but an accessor
      property of <code>Object.prototype</code>:
    </p>
    <p><img src="object-prototype-2.svg" /></p>
    <p>
      So, if <code>obj.__proto__</code> is read or set, the corresponding
      getter/setter is called from its prototype, and it gets/sets
      <code>[[Prototype]]</code>.
    </p>
    <p>
      As it was said in the beginning of this tutorial section:
      <code>__proto__</code> is a way to access <code>[[Prototype]]</code>, it
      is not <code>[[Prototype]]</code> itself.
    </p>
    <p>
      Now, if we intend to use an object as an associative array and be free of
      such problems, we can do it with a little trick:
    </p>
    <p>```js run <em>!</em> let obj = Object.create(null); <em>/!</em></p>
    <p>
      let key = prompt(“What’s the key?”, “<strong>proto</strong>”); obj[key] =
      “some value”;
    </p>
    <p>alert(obj[key]); // “some value” ```</p>
    <p>
      <code>Object.create(null)</code> creates an empty object without a
      prototype (<code>[[Prototype]]</code> is <code>null</code>):
    </p>
    <p><img src="object-prototype-null.svg" /></p>
    <p>
      So, there is no inherited getter/setter for <code>__proto__</code>. Now it
      is processed as a regular data property, so the example above works right.
    </p>
    <p>
      We can call such objects “very plain” or “pure dictionary” objects,
      because they are even simpler than the regular plain object
      <code>{...}</code>.
    </p>
    <p>
      A downside is that such objects lack any built-in object methods,
      e.g. <code>toString</code>:
    </p>
    <p>```js run <em>!</em> let obj = Object.create(null); <em>/!</em></p>
    <p>alert(obj); // Error (no toString) ```</p>
    <p>…But that’s usually fine for associative arrays.</p>
    <p>
      Note that most object-related methods are
      <code>Object.something(...)</code>, like <code>Object.keys(obj)</code> –
      they are not in the prototype, so they will keep working on such objects:
    </p>
    <p>
      ```js run let chineseDictionary = Object.create(null);
      chineseDictionary.hello = “你好”; chineseDictionary.bye = “再见”;
    </p>
    <p>alert(Object.keys(chineseDictionary)); // hello,bye ```</p>
    <h2 id="summary">Summary</h2>
    <p>Modern methods to set up and directly access the prototype are:</p>
    <ul>
      <li>
        <a href="mdn:js/Object/create">Object.create(proto, [descriptors])</a> –
        creates an empty object with a given <code>proto</code> as
        <code>[[Prototype]]</code> (can be <code>null</code>) and optional
        property descriptors.
      </li>
      <li>
        <a href="mdn:js/Object/getPrototypeOf">Object.getPrototypeOf(obj)</a> –
        returns the <code>[[Prototype]]</code> of <code>obj</code> (same as
        <code>__proto__</code> getter).
      </li>
      <li>
        <a href="mdn:js/Object/setPrototypeOf"
          >Object.setPrototypeOf(obj, proto)</a
        >
        – sets the <code>[[Prototype]]</code> of <code>obj</code> to
        <code>proto</code> (same as <code>__proto__</code> setter).
      </li>
    </ul>
    <p>
      The built-in <code>__proto__</code> getter/setter is unsafe if we’d want
      to put user-generated keys into an object. Just because a user may enter
      <code>"__proto__"</code> as the key, and there’ll be an error, with
      hopefully light, but generally unpredictable consequences.
    </p>
    <p>
      So we can either use <code>Object.create(null)</code> to create a “very
      plain” object without <code>__proto__</code>, or stick to
      <code>Map</code> objects for that.
    </p>
    <p>
      Also, <code>Object.create</code> provides an easy way to shallow-copy an
      object with all descriptors:
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> clone <span class="op">=</span> <span class="va">Object</span>.<span class="at">create</span>(</a>
<a class="sourceLine" id="cb3-2" title="2">  <span class="va">Object</span>.<span class="at">getPrototypeOf</span>(obj)<span class="op">,</span></a>
<a class="sourceLine" id="cb3-3" title="3">  <span class="va">Object</span>.<span class="at">getOwnPropertyDescriptors</span>(obj)</a>
<a class="sourceLine" id="cb3-4" title="4">)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      We also made it clear that <code>__proto__</code> is a getter/setter for
      <code>[[Prototype]]</code> and resides in <code>Object.prototype</code>,
      just like other methods.
    </p>
    <p>
      We can create an object without a prototype by
      <code>Object.create(null)</code>. Such objects are used as “pure
      dictionaries”, they have no issues with <code>"__proto__"</code> as the
      key.
    </p>
    <p>Other methods:</p>
    <ul>
      <li>
        <a href="mdn:js/Object/keys">Object.keys(obj)</a> /
        <a href="mdn:js/Object/values">Object.values(obj)</a> /
        <a href="mdn:js/Object/entries">Object.entries(obj)</a> – returns an
        array of enumerable own string property names/values/key-value pairs.
      </li>
      <li>
        <a href="mdn:js/Object/getOwnPropertySymbols"
          >Object.getOwnPropertySymbols(obj)</a
        >
        – returns an array of all own symbolic keys.
      </li>
      <li>
        <a href="mdn:js/Object/getOwnPropertyNames"
          >Object.getOwnPropertyNames(obj)</a
        >
        – returns an array of all own string keys.
      </li>
      <li>
        <a href="mdn:js/Reflect/ownKeys">Reflect.ownKeys(obj)</a> – returns an
        array of all own keys.
      </li>
      <li>
        <a href="mdn:js/Object/hasOwnProperty">obj.hasOwnProperty(key)</a>:
        returns <code>true</code> if <code>obj</code> has its own (not
        inherited) key named <code>key</code>.
      </li>
    </ul>
    <p>
      All methods that return object properties (like
      <code>Object.keys</code> and others) – return “own” properties. If we want
      inherited ones, we can use <code>for..in</code>.
    </p>
  </body>
</html>
